/*
 * "Grundkurs Programmieren in Java - Band 2 (2. Auflage, 2006)I"
 * 2003-2006, Carl Hanser Verlag
 * Loesungsvorschlag zu Aufgabe 2.1 (Version 2.0)
 * (c) 2003-2006 D. Ratz, J. Scheffler, D. Seese, J. Wiesenberger
 *
 */
 
 /** Dieser Observer macht "unsinnige" Namensaenderungen
   * rueckgaengig
   **/
public class UnfugObserver implements java.util.Observer {

  /** Ein Backup unseres Namens-Objektes */
  private Name backup;
  
  /** Konstant: eine Sammlung von unsinnigen Namen */
  private final static String[] UNSINN = {
    "DEPP","MISTKERL","SCHNARCHNASE"
  };

  /** Konstruktor. Verwendet unsere Observer-Klasse, um aus
      ihr die Namensobjekte zu erhalten. */
  public UnfugObserver(Name name) {
    backup = (Name) name.clone();
    name.addObserver(this);
  }

  /** Wenn ein Name geaendert wird, wird diese Methode aufgerufen */
  public void update(java.util.Observable n,Object o) {
    try {
      String name = ((Name) n).getName().trim().toUpperCase();
      for (int i = 0; i < UNSINN.length; i++) {
        if (UNSINN[i].equals(name)) {
          System.out.println("Unfug --> mache rueckgaengig");
          ((Name)n).setName(backup.getName());
          break;
        }
      }
      backup = (Name)((Name) n).clone();
    }
    catch(NullPointerException e) { 
      // Falls der neue Name null ist
    }
  }

}
